
The survey was constructed to focus on larger computational centers
that were enacting some level of power scheduling or resource control
to manage power usage. The drivers include the cost or availability of
power, facility and system constraints, and balancing of resources to
optimize utilization. What we observe is an evolutionary process based
on local needs and software integration that support required use
cases and integrate with the computational environment. Knobs are
being developed that provide adjustment capability.

The sites have roadmaps that are targeted toward specific needs that
include integration of in-house tools, vendor tools and systems, and
ultimately interaction with application workflows for power profiles
and integration into the user process the state of evolution in JSRM
is in the early stages of having integrated solutions that are
cross-vendor, application friendly and allow sites to utilize for
their own specific needs. There is very much of a learning curve in
process as sites do what they can to manage power under the
constraints of the practice and also strive to understand
possibilities and potential paths forward.

Recommendations:

\begin{itemize}
\item User Awareness: If you want to incentivize users toward (1)
  optimizing their codes for energy efficiency, (2) running their
  codes with tags like “optimize energy to solution” instead of
  “optimize time to solution”, (3) choosing more efficient
  architectures like accelerated architectures or ARM architectures
  instead of traditional x86-64 architectures, you must first have
  very accurate ways of measuring and reporting their energy
  consumption to them for all pieces of the computing solution
  throughout your datacenter.  This includes accurate telemetry such
  as what STFC is getting from LSF but also the feedback they are
  getting from tools like Allinea Forge (Map).  [This is the place to
  work in discussion about tools such as Forge!]
\item Energy Efficiency: STFC is the golden example of a funding
  agency (government) proscribing that energy efficiency is important
  and that funding decisions would be made based on this.  It makes
  sense for the funding agency to do this because they end up with the
  best “bang for their buck” in that the money they’re spending goes
  much more toward funding the computer and less toward funding the
  infrastructure (building, cooling, energy costs, etc.).  [Need to
  couple into this discussion details of how the USA funds
  procurement of new machine vs. running the machine on an ongoing
  basis.  This is the place to hold the discussion of how to
  incentivize centers to invest themselves into energy and power
  efficient JSRM.]
\item System and Application Software Stack: Look for opportunities
  for integration of various levels of the software stack together.
  For example, tools developers may only see characteristics of a
  piece of software revealed during static analysis while runtime
  system developers may see much more dynamic characteristics.
  Combining these is historically demonstrated as a way of improving
  both approaches effectiveness in driving improvements in
  performance, and could almost certainly drive improvements in energy
  efficiency.  Further, exposing information discovered at these
  layers to the job scheduling system could likewise have potentially
  useful outcomes, for example by allowing a job scheduler to
  understand how to schedule various applications together so as to
  achieve an overall energy goal within a datacenter.  <this would be
  a good place to cite ORNL work, possibly by Chung-Hsing Hsu +
  Suzanne Rivoire>
\item Monitoring Applications and Resources: A trend noted is the
  increase in the demand for measurable events to support analytics
  that can affect power and performance. This includes measurement
  capability that is built into hardware and software at the
  architecture level from vendors, but in the broader sense, it
  includes monitoring infrastructures that are deploying collectors
  across the system and application environment to support the
  analytic needs of many stakeholders. Power aware scheduling is one
  of those stakeholders requiring measurement data from across the
  ecosystem to optimize constraints. A challenge is to identify the
  metrics that are needed and their source to integrate for analysis
  to support the action required whither it be application or system
  centered.
\item Power Aware Ecosystem: We have identified that all of the
  efforts to further develop applications or manage power use are
  based on collection, analysis, and action utilizing the metrics that
  are part of these collection efforts. Many of these tools and
  approaches are very stove piped in that they only work in their own
  closed environment, which include vendor infrastructures. With the
  large number of efforts tackling system optimization problems
  through various means, it is imperative to have an open
  ecosystem. Establishing a standard set of collection tools,
  interfaces, and infrastructure is difficult, but the community
  should strive toward this goal to better enable the wealth of data
  required for analysis to provide feedback systems require to better
  schedule or manage power levels.  [Need standardized interfaces to
  workload managers, for use by runtimes like GEO and other system
  software components.  Now have to do something different for each
  WLM, vendor’s proprietary APIs, etc Perhaps add a high-level block
  diagram depicting different s/w stack components - job-level
  agents, job schedulers, resource manager, middleware, fabric
  manager...]
\item Managing network resources; Sid is interested in this topic;
  might include things such as reducing energy by topology-aware
  placement which (1) allows job to run faster, thus reducing overall
  energy, (2) allows job to actuate fewer network hardware, thus
  reducing power; one challenge here is that network hardware idles at
  a high power draw that doesn’t change that much when it is used
  (cf. Tiffany Mintz’s work at ORNL)
\end{itemize}
  
Is there any way to quantify the information covered in Question 7,
that is, create an objective measurement for how well an EPA JSRM
solution works?  If such an objective measure could be found, that
would be extremely interesting and could potentially be a huge
contribution to the community.




Future Possibilities 
As we better understand the needs of HPC sites and the state of the
technology in Power Aware Scheduling, we propose continued assessment
within the community with an increased scope to cover additional areas
of the HPC ecosystem and application workflow approaches that impact
power management such as increased application integration and
distributed resource scheduling that are being developed.  For example,
right now the EPA JSRM picture is mostly focused on the facility
managers because the existing batch schedulers, resource managers,
etc. are all executed with root privileges.  As the supercomputing
world moves toward technologies like Docker, etc. it makes sense that
the JSRM picture might shift toward a more user-directed role.
Consider, for example, a user’s job that executes with a user-mode
scheduler (e.g., YARN for Hadoop) that can attach to the power
telemetry to learn about consumption and leverage this plus knowledge
of the user’s application to do superior power management that is
specifically tailored to the user’s application.  One challenge with
this approach is that some sites may control access to the power
telemetry because, if it gives access to power telemetry for the whole
machine, can act as a proxy for understanding what other software on
the machine might be doing (i.e., algorithms); sites that have
high/strict security requirements probably won’t allow this to happen.
